con
_clkmode = xtal1+pll16x
_xinfreq = 5_000_000

obj
sd[2] : "fsrw_shared"
eeprom : "eeprom"
num : "numbers"
ser : "fullduplexserial"
font : "font_atari"
text : "aigeneric_driver"
key : "comboKeyboard"

var
byte filename[32]
byte buf[128]
byte filesize[2]
byte sdpin, keypin, vidpin

pub main | temp, filenum, i, fsize, addr
ser.start(31, 30, 0, 38400)
num.init
text.start(12, getptrtofonttable(0))
if \sd[0].mount(4) < 0
  text.str(string("Error! SD Card could not be mounted!"))
  abort
key.start(26)
text.str(string("Are you sure you want to install SuperDOS onto your SD card?(y/n)", 13))
temp := key.getkey
if temp == "y" or temp == "Y"
else
  text.str(string("Halting...", 13))
  abort
text.str(string("Preparing installer data...", 13))
if unpack(string("rsrc.dat")) < 0
  text.str(string("Installer data not found!", 13))
  abort
text.str(string("Installing base applications...", 13))
unpack(string("basepkg.dat"))
sd[0].popen(string("basepkg.dat"), "d")
text.str(string("Please enter the SD starting pin: "))
getkeys
sdpin := num.fromstr(@buf, num#dec)
text.str(string("Please enter the video starting pin: "))
getkeys
vidpin := num.fromstr(@buf, num#dec)
text.str(string("Please enter the keyboard starting pin: "))
getkeys
keypin := num.fromstr(@buf, num#dec)
text.str(string("Would you like to program the EEPROM with SuperDOS?", 13))
temp := key.getkey
if temp == "y" or temp == "Y"
  text.str(string("Erasing EEPROM...", 13))
  eeprom.initialize(28)
  sd[0].popen(string("superdos.bin"), "r") 
  bytefill(@filename, 0, 32)
  addr := 0
  repeat 1024
    eeprom.writepage(28, $A0, addr, @filename, 32)
    repeat until eeprom.writewait(28, $A0, addr) == 0
    addr += 32
  addr := 0
  text.str(string("Programming EEPOM...", 13))
  repeat 1026
    temp := sd[0].pread(@filename, 32)
    if temp =< 0
      quit
    if addr == $0420
      filename[$10] := sdpin
      filename[$11] := vidpin
      filename[$12] := keypin
    eeprom.writepage(28, $A0, addr, @filename, 32)
    ser.hex(addr, 4)
    ser.str(string(10, 13))
    repeat until eeprom.writewait(28, $A0, addr) == 0
    addr += 32   
text.str(string("Would you like to install the extra applications?", 13))
temp := key.getkey
if temp == "y" or temp == "Y"
  text.str(string("Installing...", 13))
  unpack(string("extrapkg.dat"))
sd[0].popen(string("extrapkg.dat"), "d")
text.str(string("Would you like to install the extra fonts?", 13))
temp := key.getkey
if temp == "y" or temp == "Y"
  text.str(string("Installing...", 13))
  unpack(string("fontpkg.dat"))
sd[0].popen(string("fontpkg.dat"), "d")
text.str(string("Would you like to install the quizzer and some quizzes?", 13))
temp := key.getkey
if temp == "y" or temp == "Y"
  text.str(string("Installing...", 13))
  unpack(string("quizpkg.dat"))
sd[0].popen(string("quizpkg.dat"), "d")
text.str(string("Would you like to install PropScript?", 13))
temp := key.getkey
if temp == "y" or temp == "Y"
  text.str(string("Installing...", 13))
  unpack(string("pspkg.dat"))
sd[0].popen(string("pspkg.dat"), "d")
text.str(string("Done!"))

pub unpack(fname) | fsize, temp, filenum, i
bytefill(@filename, 0, 34)
fsize := 0
temp := 0
filenum := 0
i := 0
if \sd[0].popen(fname, "r") < 0
  return -1
filenum := sd[0].pgetc
repeat filenum
  repeat i from 0 to 15
    temp := sd[0].pgetc
    if temp == 0
      filename[i] := 0
      quit
    filename[i] := temp
  filesize[1] := sd[0].pgetc
  filesize[0] := sd[0].pgetc
  fsize := filesize[1] << 8 | filesize[0]
  sd[1].pclose
  sd[1].popen(@filename, "w")
  repeat fsize
    sd[1].pputc(sd[0].pgetc)
sd[1].pclose

pub GetPtrToFontTable( fontNumber ) | ptr
result := font.getptrtofonttable
ptr := result
if byte[ ptr+constant(" "*8) ]~ 
  repeat constant(128 * 8)
    byte[ ptr++ ] ><= 8

pub getkeys | temp, i
repeat i from 0 to 126
  temp := key.getkey
  if temp == $C8
    i--
    text.str(string(8, " ", 8))
    buf[i--] := 0
    next
  if temp == 13
    buf[i] := 0
    text.out(temp)
    quit
  buf[i] := temp
  text.out(temp)
    